<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '../../plugins/contentful.js';
import { CONTENT_TYPES } from '../../common/content-types';
import {
  CTA as CallToAction,
  FreeTrialCTA,
  NextStepAlt,
} from '../../components/common/index.vue';
import { CopyAbout, LearnMoreCards } from '../../components/company/index.vue';
import { Showcase } from '../../components/devsecops/index.vue';
import { getPageMetadata } from '~/common/meta';
import { SolutionsHero as Hero } from '~/components/solutions/index.vue';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  name: 'Company',
  components: {
    CallToAction,
    CopyAbout,
    FreeTrialCTA,
    NextStepAlt,
    LearnMoreCards,
    Showcase,
    Hero,
  },
  mixins: [FooterEditLinkMixin],

  nuxtI18n: false,
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'company/visiting',
        include: 10,
      });
      const data = items[0].fields.pageContent;
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;

      const [cmsHero, cmsLocations, cmsAbout] = data;

      const hero = {
        data: {
          title: cmsHero.fields.title,
          image: {
            image_url: cmsHero.fields.backgroundImage.fields.file.url,
            bordered: true,
            rectangular: true,
          },
        },
        name: 'solutions-hero',
      };

      const about = {
        name: 'copy-about',
        data: {
          title: cmsLocations.fields.header,
          subtitle: cmsLocations.fields.subheader,
          description: cmsLocations.fields.text,
        },
      };

      const showcase = {
        name: 'showcase',
        data: {
          title: cmsAbout.fields.header,
          items: cmsAbout.fields.card.map((item) => {
            return {
              title: item.fields.title,
              icon: {
                name: item.fields.iconName,
                alt: item.fields.iconName,
                variant: 'marketing',
              },
              text: item.fields.description,
              link: {
                href: item.fields.cardLink,
                data_ga_name: item.fields.cardLinkDataGaName,
                data_ga_location: item.fields.cardLinkDataGaLocation,
              },
            };
          }),
        },
      };

      const company = {
        title: items[0].fields.seoMetadata[0].fields.title,
        description: items[0].fields.seoMetadata[0].fields.description,
        components: [hero, about, showcase],
      };

      return { company, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).company,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div>
    <SlpColumn>
      <component
        :is="component.name"
        v-for="(component, i) in company.components"
        :key="i"
        :data="component.data"
      />
    </SlpColumn>
    <NextStepAlt />
  </div>
</template>
